=== debian/changelog ===
ros-melodic-draco (1.3.6-3bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 11 May 2023 03:04:47 -0000
