=== debian/control ===
Source: ros-melodic-draco
Section: misc
Priority: optional
Maintainer: Martin Pecka <peckama2@fel.cvut.cz>
Build-Depends: debhelper (>= 9.0.0), cmake
Homepage: https://google.github.io/draco/
Standards-Version: 3.9.2

Package: ros-melodic-draco
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-melodic-catkin
Description: Draco is a library for compressing and decompressing 3D geometric meshes and point clouds.
 It is intended to improve the storage and transmission of 3D graphics.
